create or replace TRIGGER TRG_FCT_CONTRATO_PROPOSTAFAS
   BEFORE UPDATE ON FCT_CONTRATO FOR EACH ROW
DECLARE
   V_EXIST_PROPOSTA      NUMBER;
   V_EXIST_CONTRATOSERV  NUMBER;
   V_NRPROP_NFAT         PROPOSTAFAS.NRPROPOSFAS%TYPE;
   V_NRVERPROP_NFAT      PROPOSTAFAS.NRVERPROPFAS%TYPE;

   V_NOVOCODIGO          NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_NRPROPOSFAS         PROPOSTAFAS.NRPROPOSFAS%TYPE;
   V_NRVERPROPFAS        PROPOSTAFAS.NRVERPROPFAS%TYPE;
   V_DSREFEPROPOSFAS     PROPOSTAFAS.DSREFEPROPOSFAS%TYPE;
   V_QTSERVCONT          CONTRATOSERV.QTSERVCONT%TYPE;
   V_DTIVIGVRSERV        VALORSERV.DTIVIGVRSERV%TYPE; 
   V_CDCLIENTE           CLIENTE.CDCLIENTE%TYPE;
   V_NRORCAMENTO         FCT_ORCAMENTO.NRORCAMENTO%TYPE;
   V_DTACEITEORCA        FCT_ORCAMENTO.DTACEITEORCA%TYPE;

   V_CDTPSERVPROPINT     PAR_GERAL_FAS.CDTPSERVPROPINT%TYPE;
   V_CDOPERSOLI          PROPOSTAFAS.CDOPERSOLI%TYPE;

   V_DTANOANT            FCT_ORCAMENTO.DTACEITEORCA%TYPE;
   V_DATA                FCT_ORCAMENTO.DTACEITEORCA%TYPE;
   V_DTANO               FCT_ORCAMENTO.DTACEITEORCA%TYPE;
   V_DTANOPOS            FCT_ORCAMENTO.DTACEITEORCA%TYPE;
   V_MES                 VARCHAR2(02);

   V_DTINIACEITE         FCT_ORCAMENTO.DTACEITEORCA%TYPE;
   V_DTFINACEITE         FCT_ORCAMENTO.DTACEITEORCA%TYPE;

   V_NRPROPOSFAS_OLD     PROPOSTAFAS.NRPROPOSFAS%TYPE;
   V_NRVERPROPFAS_OLD    PROPOSTAFAS.NRVERPROPFAS%TYPE;
   V_CDCLIENTE_OLD       CLIENTE.CDCLIENTE%TYPE;
   V_NRSEQAGESERV_NEW    AGENDASERV.NRSEQAGESERV%TYPE;
   V_NRSEQAGESERV_MAX    AGENDASERV.NRSEQAGESERV%TYPE;
   V_NRSEQUCHT_MAX       CHT.NRSEQUCHT%TYPE;
   V_NRSERVPRESTDOC      SERVPRESTDOC.NRSERVPRESTDOC%TYPE;

BEGIN 
   IF :NEW.IDSITUACAOCONTRATO = 'A' AND
      :NEW.NRTIPOORCAMENTO NOT IN (2, 8, 7, 12, 17, 47, 62, 69, 73, 71, 72, 77, 79, 86, 88, 89, 90, 91, 92, 93, 94, 95, 97) THEN

      BEGIN
         SELECT CDCLIENTE, NRPROPOSFAS, NRVERPROPFAS, DSREFEPROPOSFAS
           INTO V_CDCLIENTE, V_NRPROPOSFAS, V_NRVERPROPFAS, V_DSREFEPROPOSFAS 
           FROM PROPOSTAFAS
          WHERE NRSEQCONTRATO = :NEW.NRSEQCONTRATO; 
      EXCEPTION
         WHEN NO_DATA_FOUND THEN BEGIN
            V_CDCLIENTE := NULL;
            V_NRPROPOSFAS := NULL;
            V_NRVERPROPFAS := NULL;
            V_DSREFEPROPOSFAS := NULL;
         END;   
      END;   

      BEGIN
         SELECT ORC.NRORCAMENTO, ORC.DTACEITEORCA
           INTO V_NRORCAMENTO, V_DTACEITEORCA
           FROM FCT_ORCAMENTO ORC, FCT_REFEORCACONT ROC
          WHERE ROC.NRSEQCONTRATO = :NEW.NRSEQCONTRATO
            AND ORC.NRSEQORCAMENTO = ROC.NRSEQORCAMENTO; 
      EXCEPTION
         WHEN NO_DATA_FOUND THEN BEGIN
            V_NRORCAMENTO := :NEW.NRCONTRATOFCT;
            V_DTACEITEORCA := :NEW.DTINICIOCONTRATO;
         END;   
      END;   

      IF V_NRPROPOSFAS IS NULL THEN
         NOVO_CODIGO_SC('PROPOSTAFAS', V_NOVOCODIGO, 1, 20);
         V_NRPROPOSFAS := SUBSTR(V_NOVOCODIGO, -10);
         V_NRVERPROPFAS := '01';

         BEGIN
            SELECT CDCLIENTE
              INTO V_CDCLIENTE
              FROM CLIENTE
             WHERE IDCLIEATIV = 'S'
               AND NRPARCNEGOCIO = :NEW.NRPARCNEGOCIO; 
         EXCEPTION
            WHEN NO_DATA_FOUND THEN RAISE_APPLICATION_ERROR(-20000, 'Aprovação de contrato bloqueada! Não há cliente relacionado ao parceiro de negócio '||TO_CHAR(:NEW.NRPARCNEGOCIO)||'.');
            WHEN TOO_MANY_ROWS THEN RAISE_APPLICATION_ERROR(-20001, 'Aprovação de contrato bloqueada! Existe mais de 1 cliente relacionado ao parceiro de negócio '||TO_CHAR(:NEW.NRPARCNEGOCIO)||'.');
         END;   

         INSERT INTO PROPOSTAFAS (
                     CDFILIAL,                                      
                     NRPROPOSFAS,                                   
                     NRVERPROPFAS,                                  
                     CDCLIENTE,                                     
                     NRCONTATO,                                     
                     CDOPERINCL,                                    
                     DTPROPOSFAS,                                   
                     DTVALPROPFAS,                                  
                     DTACEPROPFAS,                                  
                     IDCLIENPROSP,                                    
                     CDPROSPECT,                                    
                     DSEMAIPROFAS,                                  
                     NRFAXPROPFAS,                                  
                     IDSOLPROPFAS,                                  
                     CDTPINDICE1,                                   
                     IDPERVALOR1,                                   
                     CDINDICE1,                                     
                     VRPEINCIND1,                                   
                     CDTPINDICE2,                                   
                     IDPERVALOR2,                                   
                     CDINDICE2,                                     
                     VRPEINCIND2,                                   
                     DTBASREAJPRO,                                  
                     DSOBSPROPFAS,                                  
                     CDOPERSOLI,                                    
                     IDTPREAJPROP,                                  
                     DIFAMENSPROP,                                  
                     NRMESREAJPROP,                                 
                     CDOPERRESP,                                    
                     CDINTECLIE,                                    
                     CDINTEPROS,                                    
                     IDTIPOPROPFAS,                                 
                     CDTIPOPROPOSTA,                                
                     NRORG,                                         
                     DTINCLUSAO,                                    
                     DTULTATU,                                      
                     NRORGINCLUSAO,                                 
                     CDOPERINCLUSAO,                                
                     NRORGULTATU,                                   
                     CDOPERULTATU,                                  
                     DSREFEPROPOSFAS,                               
                     CDPROCOMERCI,                                  
                     VRPACOTESERV,                                  
                     IDTIPOCOBRSERV,                                
                     CDCLIENTEREVENDA,                              
                     CDINTECLIEREVENDA,                             
                     DSCORPROPFAS,                                  
                     IDLIBERAAGENDAMENTO,                           
                     IDATIVO,                                       
                     DSREFEPROPFAS,                                 
                     NRSEQCONTRATO                                  
                    )                                               
              values 
                    (
                     '9999',                                                                                      --CDFILIAL            NOT NULL VARCHAR2(4)   
                     V_NRPROPOSFAS,                                                                               --NRPROPOSFAS         NOT NULL VARCHAR2(20)  
                     V_NRVERPROPFAS,                                                                              --NRVERPROPFAS        NOT NULL VARCHAR2(2)   
                     V_CDCLIENTE,                                                                                 --CDCLIENTE                    VARCHAR2(21)  
                     NULL,                                                                                        --NRCONTATO                    VARCHAR2(10)  
                     :NEW.CDOPERINCLUSAO,                                                                         --CDOPERINCL          NOT NULL VARCHAR2(12)  
                     :NEW.DTINCLUSAO,                                                                             --DTPROPOSFAS         NOT NULL DATE          
                     :NEW.DTFIMCONTRATO,                                                                          --DTVALPROPFAS                 DATE          
                     V_DTACEITEORCA,                                                                              --DTACEPROPFAS                 DATE          
                     'C',                                                                                         --IDCLIENPROSP        NOT NULL VARCHAR2(1)   
                     NULL,                                                                                        --CDPROSPECT                   VARCHAR2(21)  
                     NULL,                                                                                        --DSEMAIPROFAS                 VARCHAR2(50)  
                     NULL,                                                                                        --NRFAXPROPFAS                 VARCHAR2(25)  
                     'N',                                                                                         --IDSOLPROPFAS                 VARCHAR2(1)   
                     NULL,                                                                                        --CDTPINDICE1                  VARCHAR2(1)   
                     NULL,                                                                                        --IDPERVALOR1                  VARCHAR2(1)   
                     NULL,                                                                                        --CDINDICE1                    VARCHAR2(4)   
                     NULL,                                                                                        --VRPEINCIND1                  FLOAT(126)    
                     null,                                                                                        --CDTPINDICE2                  VARCHAR2(1)   
                     null,                                                                                        --IDPERVALOR2                  VARCHAR2(1)   
                     null,                                                                                        --CDINDICE2                    VARCHAR2(4)   
                     null,                                                                                        --VRPEINCIND2                  FLOAT(126)    
                     null,                                                                                        --DTBASREAJPRO                 DATE          
                     'SITE',                                                                                      --DSOBSPROPFAS                 VARCHAR2(250) 
                     :NEW.CDOPERINCLUSAO,                                                                         --CDOPERSOLI          NOT NULL VARCHAR2(12)  
                     'A',                                                                                         --IDTPREAJPROP                 VARCHAR2(1)   
                     null,                                                                                        --DIFAMENSPROP                 FLOAT(126)    
                     null,                                                                                        --NRMESREAJPROP                VARCHAR2(2)   
                     null,                                                                                        --CDOPERRESP                   VARCHAR2(12)  
                     NULL,                                                                                        --CDINTECLIE                   VARCHAR2(2)   
                     null,                                                                                        --CDINTEPROS                   VARCHAR2(2)   
                     'S',                                                                                         --IDTIPOPROPFAS       NOT NULL VARCHAR2(1)   
                     null,                                                                                        --CDTIPOPROPOSTA               VARCHAR2(5)   
                     '20',                                                                                        --NRORG                        NUMBER        
                     SYSDATE,                                                                                     --DTINCLUSAO          NOT NULL DATE          
                     SYSDATE,                                                                                     --DTULTATU                     DATE          
                     20,                                                                                          --NRORGINCLUSAO                NUMBER        
                     '000000000997',                                                                              --CDOPERINCLUSAO               VARCHAR2(12)  
                     20,                                                                                          --NRORGULTATU                  NUMBER        
                     '000000000997',                                                                              --CDOPERULTATU                 VARCHAR2(12)  
                     'Proposta Interna  Referente ao Contrato '||V_NRORCAMENTO||' (Gerado a partir do SM)',      --DSREFEPROPOSFAS     NOT NULL VARCHAR2(100) 
                     '9999999999',                                                                                --CDPROCOMERCI        NOT NULL VARCHAR2(10)  
                     null,                                                                                        --VRPACOTESERV                 FLOAT(126)    
                     DECODE(:NEW.NRTIPOORCAMENTO, 5, 'P', 'H'),                                                   --IDTIPOCOBRSERV      NOT NULL VARCHAR2(1)   
                     null,                                                                                        --CDCLIENTEREVENDA             VARCHAR2(21)  
                     null,                                                                                        --CDINTECLIEREVENDA            VARCHAR2(2)   
                     null,                                                                                        --DSCORPROPFAS                 VARCHAR2(100) 
                     'S',                                                                                         --IDLIBERAAGENDAMENTO NOT NULL VARCHAR2(1)   
                     'S',                                                                                         --IDATIVO                      VARCHAR2(1)   
                     null,                                                                                        --DSREFEPROPFAS                VARCHAR2(100) 
                     :NEW.NRSEQCONTRATO                                                                           --NRSEQCONTRATO                NUMBER        
                    );                                                                                         
      END IF;

      FOR C_ITCONT IN (
         SELECT IT.NRITEMOCONTRATO, IT.CDSERVORCA, TS.CDTIPOSERV, IT.QTITEMCONTRATO, IT.QTMEDIDACONTR, NVL2(IT.CDTPMEDIDASERV, 'S', 'N') AS IDMEDHORA, TS.USR_QTHORASPACOTE AS QTHORASPACOTE, SUBSTR('00'||TO_CHAR(ROWNUM), -3) AS NRSERVCONT
           FROM (SELECT IT.NRSEQCONTRATO,
                        IT.CDSERVORCA,
                        IT.NRITEMOCONTRATO,
                        IT.QTITEMCONTRATO,
                        NVL(IT.QTMEDIDAFILHOS, IT.QTMEDIDACONTR) AS QTMEDIDACONTR,
                        (SELECT CDTPMEDIDASERV
                           FROM FCT_ITPRECBASESERV
                          WHERE CDSERVORCA = IT.CDSERVORCA
                            AND CDTPMEDIDASERV = 2
                            AND CDPRECBASESERV = (SELECT CDPRECBASESERV
                                                    FROM FCT_TIPOORCAMENTO
                                                   WHERE NRTIPOORCAMENTO = :NEW.NRTIPOORCAMENTO)) AS CDTPMEDIDASERV
                    FROM (
                        SELECT NRSEQCONTRATO,
                            CDSERVORCA, 
                            NRITEMOCONTRATO,
                            NRITEMCONTRATOPAI,
                            QTITEMCONTRATO,
                            QTMEDIDACONTR,
                            (SELECT SUM(ITC.QTMEDIDACONTR)
                               FROM FCT_ITEMCONTRATO ITC
                              WHERE ITC.NRITEMCONTRATOPAI = FCT_ITEMCONTRATO.NRITEMOCONTRATO
                                AND ITC.IDAPARECEPROPOSTA = 'S') AS QTMEDIDAFILHOS
                        FROM FCT_ITEMCONTRATO
                       WHERE NRITEMCONTRATOPAI IS NULL
                         AND IDAPARECEPROPOSTA = 'S') IT
                    WHERE IT.NRSEQCONTRATO = :NEW.NRSEQCONTRATO) IT, TIPOSERV TS 
          WHERE TS.CDSERVORCA = IT.CDSERVORCA
          ORDER BY IT.NRITEMOCONTRATO
      ) LOOP

         IF (C_ITCONT.QTHORASPACOTE IS NOT NULL) OR 
            (C_ITCONT.IDMEDHORA = 'S') THEN
             BEGIN
                SELECT COUNT(*)
                  INTO V_EXIST_CONTRATOSERV
                  FROM PROPOSTAFAS P, CONTRATOSERV C
                 WHERE P.NRSEQCONTRATO = :NEW.NRSEQCONTRATO
                   AND C.CDCLIENTE = P.CDCLIENTE
                   AND C.NRPROPOSFAS = P.NRPROPOSFAS
                   AND C.NRVERPROPFAS = P.NRVERPROPFAS
                   AND (C.NRITEMOCONTRATO = C_ITCONT.NRITEMOCONTRATO
                     -- OR C.CDTIPOSERV = C_ITCONT.CDTIPOSERV  /* Retirado para ocasiões que tenham dois itens com o mesmo serviço no contrato. Ex: item "Treinamento" no contrato "202312013481-01"*/
                     OR C.NRSERVCONT = C_ITCONT.NRSERVCONT);
             EXCEPTION
                WHEN NO_DATA_FOUND THEN V_EXIST_CONTRATOSERV := 0;
             END;

             IF :NEW.NRTIPOORCAMENTO = 52 THEN    -- Escopo "Serviços em Software - Mês (Instalação, Treinamento, Coordenação, Consultoria)"
                V_QTSERVCONT := 4224;
             ELSE
                V_QTSERVCONT := NVL(C_ITCONT.QTHORASPACOTE, (C_ITCONT.QTITEMCONTRATO * NVL(C_ITCONT.QTMEDIDACONTR, 1)));
             END IF;   

             IF V_EXIST_CONTRATOSERV = 0 THEN
                INSERT INTO CONTRATOSERV (
                            CDCLIENTE,
                            CDTIPOSERV,
                            DTIVIGSERV,
                            DTFVIGSERV,
                            QTSERVCONT,
                            VRDEHORACONT,
                            VRPEACHECONT,
                            VREXCEDCONT,
                            DSLOCALCONT,
                            IDTIPOCOBRCONT,
                            CDOPERSERVRESC,
                            DTCONTSERVRESC,
                            DSCONTSERVRESC,
                            NRPROPOSFAS,
                            NRVERPROPFAS,
                            NRSERVCONT,
                            NRMESREAJSERV,
                            VRHORACONT,
                            NRORG,
                            DTINCLUSAO,
                            DTULTATU,
                            NRORGINCLUSAO,
                            CDOPERINCLUSAO,
                            NRORGULTATU,
                            CDOPERULTATU,
                            IDPROPSERVWEB,
                            VRPADRAOSERVNAC,
                            VRPADRAOSERVINT,
                            IDATIVO,
                            NRITEMOCONTRATO
                           )
                    VALUES 
                           (
                            V_CDCLIENTE,                                            --CDCLIENTE       NOT NULL VARCHAR2(21)   
                            C_ITCONT.CDTIPOSERV,                                    --CDTIPOSERV      NOT NULL VARCHAR2(3)    
                            NVL(:NEW.DTINIVIGENCONT, :NEW.DTINICIOCONTRATO),        --DTIVIGSERV               DATE           
                            NVL(:NEW.DTFINVIGENCONT, :NEW.DTFIMCONTRATO),           --DTFVIGSERV               DATE           
                            V_QTSERVCONT,                                           --QTSERVCONT               FLOAT(126)     
                            '0',                                                    --VRDEHORACONT             FLOAT(126)     
                            null,                                                   --VRPEACHECONT             FLOAT(126)     
                            null,                                                   --VREXCEDCONT              FLOAT(126)     
                            null,                                                   --DSLOCALCONT              VARCHAR2(250)  
                            DECODE(:NEW.NRTIPOORCAMENTO, 5, 'P', 'H'),              --IDTIPOCOBRCONT  NOT NULL VARCHAR2(1)    
                            null,                                                   --CDOPERSERVRESC           VARCHAR2(12)   
                            null,                                                   --DTCONTSERVRESC           DATE           
                            null,                                                   --DSCONTSERVRESC           VARCHAR2(1000) 
                            V_NRPROPOSFAS,                                          --NRPROPOSFAS     NOT NULL VARCHAR2(20)   
                            V_NRVERPROPFAS,                                         --NRVERPROPFAS    NOT NULL VARCHAR2(2)    
                            C_ITCONT.NRSERVCONT,                                    --NRSERVCONT      NOT NULL VARCHAR2(3)    
                            TO_CHAR(:NEW.DTINICIOCONTRATO, 'MM'),                   --NRMESREAJSERV            VARCHAR2(2)    
                            0,                                                      --VRHORACONT      NOT NULL FLOAT(126)     
                            20,                                                     --NRORG                    NUMBER         
                            SYSDATE,                                                --DTINCLUSAO      NOT NULL DATE           
                            SYSDATE,                                                --DTULTATU                 DATE           
                            20,                                                     --NRORGINCLUSAO            NUMBER         
                            '000000000997',                                         --CDOPERINCLUSAO           VARCHAR2(12)   
                            20,                                                     --NRORGULTATU              NUMBER         
                            '000000000997',                                         --CDOPERULTATU             VARCHAR2(12)   
                            'N',                                                    --IDPROPSERVWEB   NOT NULL VARCHAR2(1)    
                            0,                                                      --VRPADRAOSERVNAC NOT NULL FLOAT(126)     
                            0,                                                      --VRPADRAOSERVINT NOT NULL FLOAT(126)     
                            'S',                                                    --IDATIVO                  VARCHAR2(1)    
                            C_ITCONT.NRITEMOCONTRATO                                --NRITEMOCONTRATO          NUMBER         
                           );
             ELSE
                IF (V_DSREFEPROPOSFAS LIKE '%(Gerado a partir do SM)%') AND 
                   (C_ITCONT.CDTIPOSERV NOT IN ('092','093','094')) THEN
                   UPDATE CONTRATOSERV
                      SET QTSERVCONT = V_QTSERVCONT,
                          DTIVIGSERV = NVL(:NEW.DTINIVIGENCONT, :NEW.DTINICIOCONTRATO),
                          DTFVIGSERV = NVL(:NEW.DTFINVIGENCONT, :NEW.DTFIMCONTRATO),
                          DTULTATU = SYSDATE
                    WHERE CDCLIENTE = V_CDCLIENTE
                      AND NRPROPOSFAS = V_NRPROPOSFAS
                      AND NRVERPROPFAS = V_NRVERPROPFAS
                      AND NRITEMOCONTRATO = C_ITCONT.NRITEMOCONTRATO;
                END IF;      
             END IF;
          END IF;   

      END LOOP; --C_ITCONT

      FOR C_VRSERV IN (
         SELECT CS.NRPROPOSFAS, CS.NRVERPROPFAS, CS.CDTIPOSERV, CS.NRSERVCONT 
           FROM CONTRATOSERV CS
          WHERE CS.CDCLIENTE = V_CDCLIENTE
            AND CS.NRPROPOSFAS = V_NRPROPOSFAS
            AND CS.NRVERPROPFAS = V_NRVERPROPFAS
            AND CS.NRITEMOCONTRATO IS NOT NULL
      ) LOOP

         BEGIN
            SELECT DTIVIGVRSERV
              INTO V_DTIVIGVRSERV
              FROM VALORSERV V
             WHERE V.NRPROPOSFAS = C_VRSERV.NRPROPOSFAS
               AND V.NRVERPROPFAS = C_VRSERV.NRVERPROPFAS
               AND V.CDTIPOSERV = C_VRSERV.CDTIPOSERV
               AND V.NRSERVCONT = C_VRSERV.NRSERVCONT
               AND V.DTIVIGVRSERV = NVL(:NEW.DTINIVIGENCONT, :NEW.DTINICIOCONTRATO);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN V_DTIVIGVRSERV := NULL;
         END;

         IF V_DTIVIGVRSERV IS NULL THEN
            INSERT INTO VALORSERV (
                        CDTIPOSERV,       
                        DTIVIGVRSERV,     
                        DTFVIGVRSERV,     
                        VRHORACLIE,       
                        NRPROPOSFAS,      
                        NRVERPROPFAS,     
                        NRSERVCONT,       
                        VRHORACLIEANT,    
                        DTATUVIGVRSERV,   
                        DSOBSREAJSERV,    
                        CDOPERREAJSERV,   
                        VRDEHORACLIE,     
                        VRDEHORACLIEANT,   
                        NRORG,            
                        DTINCLUSAO,       
                        DTULTATU,         
                        NRORGINCLUSAO,    
                        CDOPERINCLUSAO,   
                        NRORGULTATU,      
                        CDOPERULTATU,     
                        IDATIVO          
                        )
                 VALUES 
                        (
                        C_VRSERV.CDTIPOSERV,                                             --CDTIPOSERV      NOT NULL VARCHAR2(3)  
                        NVL(:NEW.DTINIVIGENCONT, :NEW.DTINICIOCONTRATO),                 --DTIVIGVRSERV    NOT NULL DATE  
                        NVL(:NEW.DTFINVIGENCONT, :NEW.DTFIMCONTRATO),                    --DTFVIGVRSERV             DATE, 
                        0,                                                               --VRHORACLIE      NOT NULL FLOAT(126)  
                        C_VRSERV.NRPROPOSFAS,                                            --NRPROPOSFAS     NOT NULL VARCHAR2(20)  
                        C_VRSERV.NRVERPROPFAS,                                           --NRVERPROPFAS    NOT NULL VARCHAR2(2)  
                        C_VRSERV.NRSERVCONT,                                             --NRSERVCONT      NOT NULL VARCHAR2(3)  
                        null,                                                            --VRHORACLIEANT            FLOAT(126), 
                        null,                                                            --DTATUVIGVRSERV           DATE, 
                        null,                                                            --DSOBSREAJSERV            VARCHAR2(2000), 
                        :NEW.CDOPERINCLUSAO,                                             --CDOPERREAJSERV           VARCHAR2(12), 
                        0,                                                               --VRDEHORACLIE    NOT NULL FLOAT(126) DEFAULT 0  
                        0,                                                               --VRDEHORACLIEANT NOT NULL FLOAT(126) DEFAULT 0  
                        20,                                                              --NRORG                    NUMBER DEFAULT sys_context('nrorg_ctx', 'nrorg'), 
                        SYSDATE,                                                         --DTINCLUSAO      NOT NULL DATE DEFAULT SYSDATE  
                        SYSDATE,                                                         --DTULTATU                 DATE, 
                        20,                                                              --NRORGINCLUSAO            NUMBER DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg'), 
                        '000000000997',                                                  --CDOPERINCLUSAO           VARCHAR2(12) DEFAULT '1', 
                        20,                                                              --NRORGULTATU              NUMBER DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg'), 
                        '000000000997',                                                  --CDOPERULTATU             VARCHAR2(12) DEFAULT '1', 
                        'S'                                                              --IDATIVO                  VARCHAR2(1) DEFAULT 'S'
                        );
         ELSE
            UPDATE VALORSERV
               SET DTIVIGVRSERV = NVL(:NEW.DTINIVIGENCONT, :NEW.DTINICIOCONTRATO),
                   DTFVIGVRSERV = NVL(:NEW.DTFINVIGENCONT, :NEW.DTFIMCONTRATO)
             WHERE NRPROPOSFAS = C_VRSERV.NRPROPOSFAS
               AND NRVERPROPFAS = C_VRSERV.NRVERPROPFAS
               AND CDTIPOSERV = C_VRSERV.CDTIPOSERV
               AND NRSERVCONT = C_VRSERV.NRSERVCONT
               AND DTIVIGVRSERV = NVL(:NEW.DTINIVIGENCONT, :NEW.DTINICIOCONTRATO);
         END IF;

      END LOOP; --C_VRSERV

      BEGIN
         SELECT MAX(NRPROPOSFAS), MAX(NRVERPROPFAS)
           INTO V_NRPROP_NFAT, V_NRVERPROP_NFAT
           FROM PROPOSTAFAS
          WHERE CDCLIENTE = V_CDCLIENTE
            AND UPPER(DSREFEPROPOSFAS) LIKE '%ATIVIDADES NÃO-FATURADAS%';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN BEGIN
            V_NRPROP_NFAT := NULL;
            V_NRVERPROP_NFAT := NULL;
         END;   
      END;

      IF V_NRPROP_NFAT IS NULL THEN
         FOR C_PROP_NFAT IN (
            SELECT DISTINCT PR.NRPROPOSFAS, PR.NRVERPROPFAS, PR.DTPROPOSFAS,
                   PR.CDOPERINCL, PR.IDCLIENPROSP, TO_CHAR(TO_NUMBER(PR.NRCONTATO)) AS NRCONTATO,
                   PR.CDPROSPECT, PR.DTVALPROPFAS, PR.DTACEPROPFAS,
                   PR.DSEMAIPROFAS, PR.CDFILIAL, PR.CDCLIENTE,
                   PR.NRFAXPROPFAS, PR.DSOBSPROPFAS, PR.IDSOLPROPFAS,
                   OP.CDOPERADOR, OP.NMOPERADOR, PR.CDOPERSOLI,
                   O1.NMOPERADOR AS OPERSOLI, CN.DSREFECONT, CL.IDTPIJURCLIE,
                   PP.IDTPIJURPROS, CN.IDTPCONTATO, PR.CDTPINDICE1,
                   PR.IDPERVALOR1, PR.CDINDICE1, PR.VRPEINCIND1,
                   PR.CDTPINDICE2, PR.IDPERVALOR2, PR.CDINDICE2,
                   PR.NRMESREAJPROP, PR.CDOPERRESP, PR.IDLIBERAAGENDAMENTO,
                   PR.VRPEINCIND2, PR.IDTPREAJPROP, A.NMINDICE AS NMINDICEREAJ1, B.NMINDICE AS NMINDICEREAJ2,
                   DECODE(CL.CDCLIENTE, '', PP.CDPROSPECT, CL.CDCLIENTE) AS CODIGO,
                   DECODE(CL.NRINSJURCLIE, '', PP.NRINSJURPROS, CL.NRINSJURCLIE) AS NRINSJURCLIE,
                   DECODE(CL.NMFANTCLIE, '', PP.NMFANTPROS, CL.NMFANTCLIE) AS NOME, PR.DSREFEPROPOSFAS,
                   PR.CDINTECLIE, PR.CDINTEPROS, PR.IDTIPOPROPFAS, PR.CDPROCOMERCI, PR.IDTIPOCOBRSERV, PR.VRPACOTESERV
              FROM PROPOSTAFAS PR, CLIENTE CL, OPERADOR OP, OPERADOR O1, PROSPECT PP,
                   CONTATO CN, INDICE A, INDICE B
             WHERE (PR.NRPROPOSFAS = V_NRPROPOSFAS) 
               AND (PR.NRVERPROPFAS = V_NRVERPROPFAS)
               AND (PR.CDOPERINCL = OP.CDOPERADOR)
               AND (PR.CDOPERSOLI = O1.CDOPERADOR)
               AND (PR.NRCONTATO = CN.NRCONTATO(+))
               AND (PR.CDPROSPECT = PP.CDPROSPECT(+))
               AND (PR.CDTPINDICE1 = A.CDTPINDICE(+))
               AND (PR.CDINDICE1 = A.CDINDICE(+))
               AND (PR.CDTPINDICE2 = B.CDTPINDICE(+))
               AND (PR.CDINDICE2 = B.CDINDICE(+))
               AND (PR.CDCLIENTE = CL.CDCLIENTE(+))
            ORDER BY NRPROPOSFAS
         ) LOOP

            NOVO_CODIGO_SC('PROPOSTAFAS', V_NOVOCODIGO, 1, 20);
            V_NRPROPOSFAS := SUBSTR(V_NOVOCODIGO, -10);
            V_NRVERPROPFAS := '01';

            BEGIN
               SELECT CDTPSERVPROPINT
                 INTO V_CDTPSERVPROPINT
                 FROM PAR_GERAL_FAS
                WHERE NRORG = 20;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN V_CDTPSERVPROPINT := NULL;
            END;

            BEGIN
               SELECT CDGERENTEIMPCLI
                 INTO V_CDOPERSOLI
                 FROM PARCLIEFAS
                WHERE CDCLIENTE = C_PROP_NFAT.CDCLIENTE
                  AND IDTPFATUCLIE = '5';
            EXCEPTION
               WHEN NO_DATA_FOUND THEN V_CDOPERSOLI := NULL;
            END;

            IF V_CDOPERSOLI IS NULL THEN
               V_CDOPERSOLI := C_PROP_NFAT.CDOPERSOLI;
            END IF;

            INSERT INTO PROPOSTAFAS (
                        NRPROPOSFAS,
                        NRVERPROPFAS,
                        IDCLIENPROSP,
                        CDFILIAL,
                        CDOPERINCL,
                        DTPROPOSFAS,
                        DTVALPROPFAS,
                        DTACEPROPFAS,                                  
                        NRCONTATO,
                        CDCLIENTE,
                        CDPROSPECT,
                        DSEMAIPROFAS,
                        NRFAXPROPFAS,
                        DSOBSPROPFAS,
                        IDSOLPROPFAS,
                        CDTPINDICE1,
                        IDPERVALOR1,
                        CDINDICE1,
                        VRPEINCIND1,
                        CDTPINDICE2,
                        IDPERVALOR2,
                        CDINDICE2,
                        VRPEINCIND2,
                        IDTPREAJPROP,
                        CDOPERSOLI,
                        NRMESREAJPROP,
                        CDOPERRESP,
                        DSREFEPROPOSFAS,
                        CDINTECLIE,
                        CDINTEPROS,
                        IDTIPOPROPFAS,
                        CDPROCOMERCI,
                        IDTIPOCOBRSERV,
                        VRPACOTESERV,
                        NRORG,
                        DTINCLUSAO,
                        IDLIBERAAGENDAMENTO
                       )                                               
                 values 
                       (
                        V_NRPROPOSFAS,                                                                                       --NRPROPOSFAS     
                        V_NRVERPROPFAS,                                                                                      --NRVERPROPFAS
                        C_PROP_NFAT.IDCLIENPROSP,                                                                            --IDCLIENPROSP
                        C_PROP_NFAT.CDFILIAL,                                                                                --CDFILIAL
                        C_PROP_NFAT.CDOPERINCL,                                                                              --CDOPERINCL
                        TRUNC(SYSDATE),                                                                                      --DTPROPOSFAS
                        TRUNC(SYSDATE)+30,                                                                                   --DTVALPROPFAS
                        C_PROP_NFAT.DTACEPROPFAS,                                                                            --DTACEPROPFAS
                        C_PROP_NFAT.NRCONTATO,                                                                               --NRCONTATO
                        C_PROP_NFAT.CDCLIENTE,                                                                               --CDCLIENTE
                        C_PROP_NFAT.CDPROSPECT,                                                                              --CDPROSPECT
                        C_PROP_NFAT.DSEMAIPROFAS,                                                                            --DSEMAIPROFAS
                        C_PROP_NFAT.NRFAXPROPFAS,                                                                            --NRFAXPROPFAS
                        C_PROP_NFAT.DSOBSPROPFAS,                                                                            --DSOBSPROPFAS
                        'N',                                                                                                 --IDSOLPROPFAS
                        C_PROP_NFAT.CDTPINDICE1,                                                                             --CDTPINDICE1
                        C_PROP_NFAT.IDPERVALOR1,                                                                             --IDPERVALOR1
                        C_PROP_NFAT.CDINDICE1,                                                                               --CDINDICE1
                        C_PROP_NFAT.VRPEINCIND1,                                                                             --VRPEINCIND1
                        C_PROP_NFAT.CDTPINDICE2,                                                                             --CDTPINDICE2
                        C_PROP_NFAT.IDPERVALOR2,                                                                             --IDPERVALOR2
                        C_PROP_NFAT.CDINDICE2,                                                                               --CDINDICE2
                        C_PROP_NFAT.VRPEINCIND2,                                                                             --VRPEINCIND2
                        C_PROP_NFAT.IDTPREAJPROP,                                                                            --IDTPREAJPROP
                        V_CDOPERSOLI,                                                                                        --CDOPERSOLI
                        C_PROP_NFAT.NRMESREAJPROP,                                                                           --NRMESREAJPROP
                        C_PROP_NFAT.CDOPERRESP,                                                                              --CDOPERRESP
                        'Proposta interna - Atividades não-faturadas (Gerado no aceite da proposta '||V_NRORCAMENTO||')',    --DSREFEPROPOSFAS
                        C_PROP_NFAT.CDINTECLIE,                                                                              --CDINTECLIE
                        C_PROP_NFAT.CDINTEPROS,                                                                              --CDINTEPROS
                        C_PROP_NFAT.IDTIPOPROPFAS,                                                                           --IDTIPOPROPFAS
                        C_PROP_NFAT.CDPROCOMERCI,                                                                            --CDPROCOMERCI
                        'H',                                                                                                 --IDTIPOCOBRSERV
                        C_PROP_NFAT.VRPACOTESERV,                                                                            --VRPACOTESERV
                        20,                                                                                                  --NRORG
                        SYSDATE,                                                                                             --DTINCLUSAO
                        C_PROP_NFAT.IDLIBERAAGENDAMENTO                                                                      --IDLIBERAAGENDAMENTO
                       );       

            BEGIN
               SELECT
                 ADD_MONTHS(TO_DATE('01/'||TO_CHAR(V_DTACEITEORCA, 'MM') ||'/'||SUBSTR(TO_CHAR(V_DTACEITEORCA, 'DD/MM/YYYY'), 7, 4)), -12)  AS DTANOANT,
                 ADD_MONTHS(TO_DATE('01/'||TO_CHAR(V_DTACEITEORCA, 'MM') ||'/'||SUBSTR(TO_CHAR(V_DTACEITEORCA, 'DD/MM/YYYY'), 7, 4)), 0) AS DATA,
                 ADD_MONTHS(TO_DATE('01/'||TO_CHAR(V_DTACEITEORCA, 'MM') ||'/'||SUBSTR(TO_CHAR(V_DTACEITEORCA, 'DD/MM/YYYY'), 7, 4)), 0) - 1 AS DTANO,
                 ADD_MONTHS(TO_DATE('01/'||TO_CHAR(V_DTACEITEORCA, 'MM') ||'/'||SUBSTR(TO_CHAR(V_DTACEITEORCA, 'DD/MM/YYYY'), 7, 4)), 12) - 1  AS DTANOPOS,
                 TO_CHAR(V_DTACEITEORCA, 'MM') AS MES
                INTO V_DTANOANT, V_DATA, V_DTANO, V_DTANOPOS, V_MES
                FROM DUAL;                       
            EXCEPTION
               WHEN NO_DATA_FOUND THEN BEGIN 
                  V_DTANOANT := NULL;
                  V_DATA := NULL;
                  V_DTANO := NULL;
                  V_DTANOPOS := NULL;
                  V_MES := NULL;
               END;   
            END;

            IF (TO_CHAR(V_DTACEITEORCA, 'MM') > V_MES) THEN
                V_DTFINACEITE := V_DATA;
                V_DTINIACEITE := V_DTANOANT;
            ELSE
                V_DTFINACEITE := V_DTANOPOS;
                V_DTINIACEITE := V_DATA;
            END IF;

            INSERT INTO CONTRATOSERV (
                        NRPROPOSFAS,     
                        NRVERPROPFAS,    
                        CDCLIENTE,       
                        CDTIPOSERV,      
                        IDTIPOCOBRCONT,  
                        QTSERVCONT,      
                        VRHORACONT,      
                        VRDEHORACONT,    
                        VRPEACHECONT,    
                        VREXCEDCONT,     
                        DSLOCALCONT,     
                        NRSERVCONT,      
                        NRMESREAJSERV,   
                        DTIVIGSERV,      
                        DTFVIGSERV,      
                        NRORG,           
                        DTINCLUSAO,      
                        IDPROPSERVWEB   
                       )
                VALUES 
                       (
                        V_NRPROPOSFAS,                                          --NRPROPOSFAS     
                        V_NRVERPROPFAS,                                         --NRVERPROPFAS
                        C_PROP_NFAT.CDCLIENTE,                                  --CDCLIENTE
                        V_CDTPSERVPROPINT,                                      --CDTIPOSERV      
                        'H',                                                    --IDTIPOCOBRCONT  
                        999999999,                                              --QTSERVCONT      
                        1,                                                      --VRHORACONT      
                        0,                                                      --VRDEHORACONT    
                        1.5,                                                    --VRPEACHECONT    
                        NULL,                                                   --VREXCEDCONT     
                        '',                                                     --DSLOCALCONT     
                        '001',                                                  --NRSERVCONT      
                        C_PROP_NFAT.NRMESREAJPROP,                              --NRMESREAJSERV   
                        V_DTINIACEITE,                                          --DTIVIGSERV      
                        V_DTFINACEITE,                                          --DTFVIGSERV      
                        20,                                                     --NRORG           
                        SYSDATE,                                                --DTINCLUSAO      
                        'N'                                                     --IDPROPSERVWEB   
                       );

            INSERT INTO VALORSERV (
                        CDTIPOSERV,
                        DTIVIGVRSERV,   
                        DTFVIGVRSERV,   
                        VRHORACLIE,     
                        VRDEHORACLIE,   
                        VRDEHORACLIEANT,
                        NRPROPOSFAS,    
                        NRVERPROPFAS,   
                        NRSERVCONT,     
                        NRORG,          
                        DTINCLUSAO     
                       )
                 VALUES 
                       (
                        V_CDTPSERVPROPINT,                                       --CDTIPOSERV     
                        V_DTINIACEITE,                                          --DTIVIGVRSERV   
                        V_DTFINACEITE,                                          --DTFVIGVRSERV   
                        1,                                                      --VRHORACLIE     
                        0,                                                      --VRDEHORACLIE   
                        0,                                                      --VRDEHORACLIEANT
                        V_NRPROPOSFAS,                                          --NRPROPOSFAS     
                        V_NRVERPROPFAS,                                         --NRVERPROPFAS
                        '001',                                                  --NRSERVCONT     
                        20,                                                     --NRORG          
                        SYSDATE                                                 --DTINCLUSAO     
                       );

            INSERT INTO PROPOSTASERV (
                        NRPROPOSFAS,    
                        NRVERPROPFAS,   
                        CDTIPOSERV,     
                        VRHORAPROP,     
                        QTSERVPROP,     
                        IDTIPOCOBRPROP, 
                        VRDEHORAPROP,   
                        VRPEACHEPROP,   
                        VREXCEDPROP,    
                        DSLOCALPROP,    
                        NRSERVPROP,     
                        NRORG,          
                        DTINCLUSAO     
                       )
                 VALUES 
                       (
                        V_NRPROPOSFAS,                                          --NRPROPOSFAS     
                        V_NRVERPROPFAS,                                         --NRVERPROPFAS
                        V_CDTPSERVPROPINT,                                      --CDTIPOSERV     
                        1,                                                      --VRHORAPROP    
                        999999999,                                              --QTSERVPROP    
                        'H',                                                    --IDTIPOCOBRPROP
                        0,                                                      --VRDEHORAPROP  
                        1.5,                                                    --VRPEACHEPROP  
                        NULL,                                                   --VREXCEDPROP   
                        '',                                                     --DSLOCALPROP   
                        '001',                                                  --NRSERVPROP    
                        20,                                                     --NRORG         
                        SYSDATE                                                 --DTINCLUSAO    
                       );

         END LOOP; --C_PROP_NFAT
      ELSE
         BEGIN
            SELECT CDTPSERVPROPINT
              INTO V_CDTPSERVPROPINT
              FROM PAR_GERAL_FAS
             WHERE NRORG = 20;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN V_CDTPSERVPROPINT := NULL;
         END;

         BEGIN
            SELECT MAX(DTFVIGVRSERV)
              INTO V_DTFINACEITE
              FROM VALORSERV
             WHERE NRPROPOSFAS = V_NRPROP_NFAT
               AND NRVERPROPFAS = V_NRVERPROP_NFAT
               AND CDTIPOSERV = V_CDTPSERVPROPINT
               AND NRSERVCONT = '001';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN V_DTFINACEITE := NULL;
         END;

         IF V_DTFINACEITE IS NOT NULL AND V_DTFINACEITE < SYSDATE THEN
            V_DTINIACEITE := V_DTFINACEITE + 1;

            BEGIN
               SELECT
                 ADD_MONTHS(TO_DATE('01/'||TO_CHAR(V_DTACEITEORCA, 'MM') ||'/'||SUBSTR(TO_CHAR(V_DTACEITEORCA, 'DD/MM/YYYY'), 7, 4)), -12)  AS DTANOANT,
                 ADD_MONTHS(TO_DATE('01/'||TO_CHAR(V_DTACEITEORCA, 'MM') ||'/'||SUBSTR(TO_CHAR(V_DTACEITEORCA, 'DD/MM/YYYY'), 7, 4)), 0) AS DATA,
                 ADD_MONTHS(TO_DATE('01/'||TO_CHAR(V_DTACEITEORCA, 'MM') ||'/'||SUBSTR(TO_CHAR(V_DTACEITEORCA, 'DD/MM/YYYY'), 7, 4)), 0) - 1 AS DTANO,
                 ADD_MONTHS(TO_DATE('01/'||TO_CHAR(V_DTACEITEORCA, 'MM') ||'/'||SUBSTR(TO_CHAR(V_DTACEITEORCA, 'DD/MM/YYYY'), 7, 4)), 12) - 1  AS DTANOPOS,
                 TO_CHAR(V_DTACEITEORCA, 'MM') AS MES
                INTO V_DTANOANT, V_DATA, V_DTANO, V_DTANOPOS, V_MES
                FROM DUAL;                       
            EXCEPTION
               WHEN NO_DATA_FOUND THEN BEGIN 
                  V_DTANOANT := NULL;
                  V_DATA := NULL;
                  V_DTANO := NULL;
                  V_DTANOPOS := NULL;
                  V_MES := NULL;
               END;   
            END;

            IF (TO_CHAR(V_DTACEITEORCA, 'MM') > V_MES) THEN
                V_DTFINACEITE := V_DATA;
            ELSE
                V_DTFINACEITE := V_DTANOPOS;
            END IF;

            UPDATE CONTRATOSERV
               SET DTFVIGSERV = V_DTFINACEITE,
                   CDOPERSERVRESC = NULL,
                   DTCONTSERVRESC = NULL,
                   DSCONTSERVRESC = NULL
             WHERE NRPROPOSFAS = V_NRPROP_NFAT    
               AND NRVERPROPFAS = V_NRVERPROP_NFAT
               AND CDTIPOSERV = V_CDTPSERVPROPINT     
               AND NRSERVCONT = '001';

            BEGIN
               SELECT DTIVIGVRSERV
                 INTO V_DTIVIGVRSERV
                 FROM VALORSERV V
                WHERE V.NRPROPOSFAS = V_NRPROP_NFAT
                  AND V.NRVERPROPFAS = V_NRVERPROP_NFAT
                  AND V.CDTIPOSERV = V_CDTPSERVPROPINT
                  AND V.NRSERVCONT = '001'
                  AND V.DTIVIGVRSERV = V_DTINIACEITE;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN V_DTIVIGVRSERV := NULL;
            END;

            IF V_DTIVIGVRSERV IS NULL THEN
               INSERT INTO VALORSERV (
                           CDTIPOSERV,
                           DTIVIGVRSERV,   
                           DTFVIGVRSERV,   
                           VRHORACLIE,     
                           VRDEHORACLIE,   
                           VRDEHORACLIEANT,
                           NRPROPOSFAS,    
                           NRVERPROPFAS,   
                           NRSERVCONT,     
                           NRORG,          
                           DTINCLUSAO     
                          )
                    VALUES 
                          (
                           V_CDTPSERVPROPINT,                                      --CDTIPOSERV     
                           V_DTINIACEITE,                                          --DTIVIGVRSERV   
                           V_DTFINACEITE,                                          --DTFVIGVRSERV   
                           1,                                                      --VRHORACLIE     
                           0,                                                      --VRDEHORACLIE   
                           0,                                                      --VRDEHORACLIEANT
                           V_NRPROP_NFAT,                                          --NRPROPOSFAS     
                           V_NRVERPROP_NFAT,                                       --NRVERPROPFAS
                           '001',                                                  --NRSERVCONT     
                           20,                                                     --NRORG          
                           SYSDATE                                                 --DTINCLUSAO     
                          );
            ELSE
               UPDATE VALORSERV
                  SET DTFVIGVRSERV = V_DTFINACEITE
                WHERE NRPROPOSFAS = V_NRPROP_NFAT
                  AND NRVERPROPFAS = V_NRVERPROP_NFAT
                  AND CDTIPOSERV = V_CDTPSERVPROPINT
                  AND NRSERVCONT = '001'
                  AND DTIVIGVRSERV = V_DTINIACEITE;
            END IF;
         END IF;      
      END IF;

      /* ATUALIZA DADOS DA CDA PÓS RENEGOCIAÇÃO DE CONTRATO*/

	  IF ((:NEW.NRVERSAOCONTRATO > 1) AND (:OLD.IDSITUACAOCONTRATO <> 'A')) THEN

		  BEGIN
			 SELECT CDCLIENTE, NRPROPOSFAS, NRVERPROPFAS
			   INTO V_CDCLIENTE_OLD, V_NRPROPOSFAS_OLD, V_NRVERPROPFAS_OLD 
			   FROM PROPOSTAFAS
			  WHERE NRSEQCONTRATO = :NEW.NRSEQCONTRATOPAI; 
		  EXCEPTION
			 WHEN NO_DATA_FOUND THEN BEGIN
				V_CDCLIENTE_OLD := NULL;
				V_NRPROPOSFAS_OLD := NULL;
				V_NRVERPROPFAS_OLD := NULL;
			 END;   
		  END;

		/* AGENDASERV: Caso tenha algum agendamento em que a troca do CNPJ esteja dentro do período, deve ser criado um novo agendamento à partir da data de alteração do CNPJ para o cliente novo e alterada a data final do agendamento do antigo para um dia antes da troca do CNPJ.  Caso existam outros agendamentos posteriores à data da troca do CNPJ, esses devem ser alterados para o cliente novo. */

		FOR C_AGEND IN (SELECT NRPROPOSFAS, NRVERPROPFAS, CDEMPRESA, CDFUNC, NRSEQAGESERV, HRENT1HBAGES, HRSAI1HBAGES, 
		                       HRENT2HBAGES, HRSAI2HBAGES, QTHORTRASERV, VRPEHEXTSERV, DTINITRASERV, DTFINTRASERV, 
		                       DIINIAPUSERV, DIFINAPUSERV, VRPECOMFUNSE, CDTIPOSERV, NRSERVCONT, USR_NRSERVPEDP,
		                       USR_CDCLIENTE, IDSERVCOMIS, NRORG, IDATIVO
						  FROM AGENDASERV
						 WHERE NRPROPOSFAS = V_NRPROPOSFAS_OLD
						   AND NRVERPROPFAS = V_NRVERPROPFAS_OLD
						   AND TRUNC(DTFINTRASERV) >= TRUNC(NVL(:NEW.DTINIVIGENCONT, :NEW.DTINICIOCONTRATO))
					  ORDER BY DTINITRASERV) LOOP

			IF (TRUNC(C_AGEND.DTINITRASERV) >= TRUNC(NVL(:NEW.DTINIVIGENCONT, :NEW.DTINICIOCONTRATO))) THEN

				/* Se o período do agendamento estiver inteiramente após a data de início do contrato renegociado, devem ser alterados os dados do agendamento*/

				BEGIN
					SELECT TO_CHAR(LPAD((TO_NUMBER(MAX(NRSEQAGESERV))+1),3,'0'))
					  INTO V_NRSEQAGESERV_MAX
					  FROM AGENDASERV
					 WHERE NRPROPOSFAS = V_NRPROPOSFAS
			           AND NRVERPROPFAS = V_NRVERPROPFAS
					   AND CDTIPOSERV = C_AGEND.CDTIPOSERV
					   AND NRSERVCONT = C_AGEND.NRSERVCONT;
				EXCEPTION 
					WHEN NO_DATA_FOUND THEN BEGIN
						V_NRSEQAGESERV_MAX := '001';
					END;
				END;

				IF (V_NRSEQAGESERV_MAX IS NULL) THEN
					V_NRSEQAGESERV_MAX := '001';
				END IF;

				UPDATE SERVPREST
				   SET NRSEQAGESERV = NULL
				 WHERE NRPROPOSFAS = C_AGEND.NRPROPOSFAS
				   AND NRVERPROPFAS = C_AGEND.NRVERPROPFAS
				   AND NRSEQAGESERV = C_AGEND.NRSEQAGESERV
                   AND CDTIPOSERV = C_AGEND.CDTIPOSERV
                   AND NRSERVCONT = C_AGEND.NRSERVCONT;

				UPDATE AGENDASERV
				   SET NRPROPOSFAS = V_NRPROPOSFAS,
			           NRVERPROPFAS = V_NRVERPROPFAS,
					   NRSEQAGESERV = V_NRSEQAGESERV_MAX
				 WHERE NRPROPOSFAS = C_AGEND.NRPROPOSFAS
				   AND NRVERPROPFAS = C_AGEND.NRVERPROPFAS
				   AND NRSEQAGESERV = C_AGEND.NRSEQAGESERV
                   AND CDTIPOSERV = C_AGEND.CDTIPOSERV
                   AND NRSERVCONT = C_AGEND.NRSERVCONT;

			ELSE
			    /* Se o periodo do agendamento estiver no meio da data de início do contrato renegociado, é criado um novo agendamento à partir da data de início do contrato renegociado, e alterado o agendamento do contrato anterior para terminar um dia antes da data de início do contrato renegociado*/

			    UPDATE AGENDASERV
				   SET DTFINTRASERV = TRUNC(NVL(:NEW.DTINIVIGENCONT, :NEW.DTINICIOCONTRATO))-1
				 WHERE NRPROPOSFAS = C_AGEND.NRPROPOSFAS
				   AND NRVERPROPFAS = C_AGEND.NRVERPROPFAS
				   AND NRSEQAGESERV = C_AGEND.NRSEQAGESERV
                   AND CDTIPOSERV = C_AGEND.CDTIPOSERV
                   AND NRSERVCONT = C_AGEND.NRSERVCONT;

				BEGIN
					SELECT TO_CHAR(LPAD((TO_NUMBER(MAX(NRSEQAGESERV))+1),3,'0'))
					  INTO V_NRSEQAGESERV_MAX
					  FROM AGENDASERV
					 WHERE NRPROPOSFAS = V_NRPROPOSFAS
			           AND NRVERPROPFAS = V_NRVERPROPFAS
					   AND CDTIPOSERV = C_AGEND.CDTIPOSERV
					   AND NRSERVCONT = C_AGEND.NRSERVCONT;
				EXCEPTION 
					WHEN NO_DATA_FOUND THEN BEGIN
						V_NRSEQAGESERV_MAX := '001';
					END;
				END;

				IF (V_NRSEQAGESERV_MAX IS NULL) THEN
					V_NRSEQAGESERV_MAX := '001';
				END IF;

				INSERT INTO AGENDASERV(NRPROPOSFAS, NRVERPROPFAS, CDEMPRESA, CDFUNC, NRSEQAGESERV, 
				                       HRENT1HBAGES, HRSAI1HBAGES, HRENT2HBAGES, HRSAI2HBAGES, QTHORTRASERV, 
									   VRPEHEXTSERV, DTINITRASERV, DTFINTRASERV, DIINIAPUSERV, DIFINAPUSERV, 
									   VRPECOMFUNSE, CDTIPOSERV, NRSERVCONT, USR_NRSERVPEDP, USR_CDCLIENTE, 
									   IDSERVCOMIS, NRORG, IDATIVO, DTINCLUSAO, CDOPERINCLUSAO, 
									   NRORGINCLUSAO)
				        VALUES(V_NRPROPOSFAS, V_NRVERPROPFAS, C_AGEND.CDEMPRESA, C_AGEND.CDFUNC, V_NRSEQAGESERV_MAX, 
						       C_AGEND.HRENT1HBAGES, C_AGEND.HRSAI1HBAGES, C_AGEND.HRENT2HBAGES, C_AGEND.HRSAI2HBAGES, C_AGEND.QTHORTRASERV, 
							   C_AGEND.VRPEHEXTSERV, TRUNC(NVL(:NEW.DTINIVIGENCONT, :NEW.DTINICIOCONTRATO)), C_AGEND.DTFINTRASERV, C_AGEND.DIINIAPUSERV, C_AGEND.DIFINAPUSERV, 
							   C_AGEND.VRPECOMFUNSE, C_AGEND.CDTIPOSERV, C_AGEND.NRSERVCONT, C_AGEND.USR_NRSERVPEDP, C_AGEND.USR_CDCLIENTE, 
							   C_AGEND.IDSERVCOMIS, C_AGEND.NRORG, C_AGEND.IDATIVO, SYSDATE, '000000000997', 
							   C_AGEND.NRORG);


			END IF;
		END LOOP;

		/*CHT: Copiar as CHTS que estiverem correspondentes ao período da renegociação, alterando a Proposta(NRPROPOSFAS), Versão (NRVERPROPFAS) e Cliente (CDCLIENTE)*/


	    FOR C_CHT IN (SELECT NRPROPOSFAS, NRVERPROPFAS, CDTIPOSERV, NRSERVCONT, NRSEQUCHT, CDEMPRESA, 
							 CDFUNC, CDOPERINCL, DSREFECHT, DTINCLCHT, DTINICCHT, DTFINACHT, IDSTATUSCHT, 
                             QTHRAPROFATUCHT, QTHREXTRSERVCHT, QTHRAPRCOMISCHT, DSALTERACAOCHT, CDCLIENTE, 
                             IDRELACMANUALNF, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, 
                             NRORGULTATU, CDOPERULTATU, IDCHTASSINADA, IDCHTPGTOOK, IDATIVO, NRSEQCONTRATO 
                        FROM CHT
					   WHERE CDCLIENTE = V_CDCLIENTE_OLD
		                 AND NRPROPOSFAS = V_NRPROPOSFAS_OLD
		                 AND NRVERPROPFAS = V_NRVERPROPFAS_OLD
						 AND TRUNC(DTFINACHT) >= TRUNC(NVL(:NEW.DTINIVIGENCONT, :NEW.DTINICIOCONTRATO))) LOOP

			BEGIN
				SELECT TO_CHAR(LPAD((TO_NUMBER(MAX(NRSEQUCHT))+1),5,'0'))
				  INTO V_NRSEQUCHT_MAX
				  FROM CHT
				 WHERE NRPROPOSFAS = V_NRPROPOSFAS
				   AND NRVERPROPFAS = V_NRVERPROPFAS
				   AND CDTIPOSERV = C_CHT.CDTIPOSERV
				   AND NRSERVCONT = C_CHT.NRSERVCONT;
			EXCEPTION 
				WHEN NO_DATA_FOUND THEN BEGIN
					V_NRSEQUCHT_MAX := '00001';
				END;
			END;

			IF (V_NRSEQUCHT_MAX IS NULL) THEN
				V_NRSEQUCHT_MAX := '00001';
			END IF;

			INSERT INTO CHT(NRPROPOSFAS, NRVERPROPFAS, CDTIPOSERV, NRSERVCONT, NRSEQUCHT, CDEMPRESA, 
							CDFUNC, CDOPERINCL, DSREFECHT, DTINCLCHT, DTINICCHT, DTFINACHT, IDSTATUSCHT, 
							QTHRAPROFATUCHT, QTHREXTRSERVCHT, QTHRAPRCOMISCHT, DSALTERACAOCHT, CDCLIENTE, 
							IDRELACMANUALNF, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, 
							NRORGULTATU, CDOPERULTATU, IDCHTASSINADA, IDCHTPGTOOK, IDATIVO, NRSEQCONTRATO)
					VALUES (V_NRPROPOSFAS, V_NRVERPROPFAS, C_CHT.CDTIPOSERV, C_CHT.NRSERVCONT, V_NRSEQUCHT_MAX, C_CHT.CDEMPRESA, 
							C_CHT.CDFUNC, '000000000997', C_CHT.DSREFECHT, C_CHT.DTINCLCHT, C_CHT.DTINICCHT, C_CHT.DTFINACHT, C_CHT.IDSTATUSCHT, 
							C_CHT.QTHRAPROFATUCHT, C_CHT.QTHREXTRSERVCHT, C_CHT.QTHRAPRCOMISCHT, C_CHT.DSALTERACAOCHT, V_CDCLIENTE, 
							C_CHT.IDRELACMANUALNF, C_CHT.NRORG, SYSDATE, NULL, C_CHT.NRORGINCLUSAO, '000000000997', 
							NULL, NULL, C_CHT.IDCHTASSINADA, C_CHT.IDCHTPGTOOK, C_CHT.IDATIVO, C_CHT.NRSEQCONTRATO);


			/*SERVPREST: Alterar o registro para mudar do cliente antigo para o cliente novo, somente para os registros que forem à partir da DATA INICIAL do contrato renegociado*/	

			FOR C_SERVPRST IN (SELECT NRPROPOSFAS, NRVERPROPFAS, CDFUNC, CDCLIENTE, DTSERVPREST, CDTIPOSERV, NRSERVCONT,
                                      CDEMPRESA, NRSERVPREST
			                     FROM SERVPREST
			                    WHERE CDCLIENTE = V_CDCLIENTE_OLD
								  AND NRPROPOSFAS = V_NRPROPOSFAS_OLD
			                      AND NRVERPROPFAS = V_NRVERPROPFAS_OLD
                                  AND CDTIPOSERV = C_CHT.CDTIPOSERV
                                  AND NRSERVCONT = C_CHT.NRSERVCONT
			                      AND NRSEQUCHT = C_CHT.NRSEQUCHT
			                      AND TRUNC(DTSERVPREST) >= TRUNC(NVL(:NEW.DTINIVIGENCONT, :NEW.DTINICIOCONTRATO)))LOOP

				BEGIN
					SELECT MAX(NRSEQAGESERV)
					  INTO V_NRSEQAGESERV_NEW
					  FROM AGENDASERV
					 WHERE NRPROPOSFAS = V_NRPROPOSFAS
			           AND NRVERPROPFAS = V_NRVERPROPFAS
					   AND CDTIPOSERV = C_CHT.CDTIPOSERV
					   AND NRSERVCONT = C_CHT.NRSERVCONT
					   AND C_SERVPRST.DTSERVPREST BETWEEN DTINITRASERV AND DTFINTRASERV;
				END;
				
				UPDATE SERVPREST
				   SET CDCLIENTE = V_CDCLIENTE,
					   NRPROPOSFAS = V_NRPROPOSFAS,
					   NRVERPROPFAS = V_NRVERPROPFAS,
					   NRSEQUCHT = V_NRSEQUCHT_MAX,
					   NRSEQAGESERV = V_NRSEQAGESERV_NEW
				 WHERE CDCLIENTE = C_SERVPRST.CDCLIENTE
				   AND NRPROPOSFAS = C_SERVPRST.NRPROPOSFAS
				   AND NRVERPROPFAS = C_SERVPRST.NRVERPROPFAS
				   AND NRSEQUCHT = C_CHT.NRSEQUCHT
				   AND DTSERVPREST = C_SERVPRST.DTSERVPREST
				   AND CDTIPOSERV = C_SERVPRST.CDTIPOSERV 
				   AND NRSERVCONT = C_SERVPRST.NRSERVCONT
				   AND NRSERVPREST = C_SERVPRST.NRSERVPREST
				   AND CDEMPRESA = C_SERVPRST.CDEMPRESA
				   AND CDFUNC = C_SERVPRST.CDFUNC;
					   
			END LOOP;
		END LOOP;


		/*SERVPREST:  Alterar o registro para mudar do cliente antigo para o cliente novo, somente para os registros que forem à partir da DATA INICIAL do contrato renegociado (Realizando a mudança para as CDAS que não estão vinculadas com CHT)*/

		FOR C_SERVPRST IN (SELECT NRPROPOSFAS, NRVERPROPFAS, CDFUNC, CDCLIENTE, DTSERVPREST, CDTIPOSERV, NRSERVCONT,
		                          CDEMPRESA, NRSERVPREST
		                     FROM SERVPREST
			                WHERE CDCLIENTE = V_CDCLIENTE_OLD
							  AND NRPROPOSFAS = V_NRPROPOSFAS_OLD
			                  AND NRVERPROPFAS = V_NRVERPROPFAS_OLD
			                  AND NRSEQUCHT IS NULL
			                  AND TRUNC(DTSERVPREST) >= TRUNC(NVL(:NEW.DTINIVIGENCONT, :NEW.DTINICIOCONTRATO)))LOOP

				BEGIN
					SELECT MAX(NRSEQAGESERV)
					  INTO V_NRSEQAGESERV_NEW
					  FROM AGENDASERV
					 WHERE NRPROPOSFAS = V_NRPROPOSFAS
			           AND NRVERPROPFAS = V_NRVERPROPFAS
					   AND CDTIPOSERV = C_SERVPRST.CDTIPOSERV
					   AND NRSERVCONT = C_SERVPRST.NRSERVCONT
					   AND C_SERVPRST.DTSERVPREST BETWEEN DTINITRASERV AND DTFINTRASERV;
				END;
				
				UPDATE SERVPREST
				   SET CDCLIENTE = V_CDCLIENTE,
					   NRPROPOSFAS = V_NRPROPOSFAS,
					   NRVERPROPFAS = V_NRVERPROPFAS,
					   NRSEQAGESERV = V_NRSEQAGESERV_NEW
				 WHERE CDCLIENTE = C_SERVPRST.CDCLIENTE
				   AND NRPROPOSFAS = C_SERVPRST.NRPROPOSFAS
				   AND NRVERPROPFAS = C_SERVPRST.NRVERPROPFAS
				   AND NRSEQUCHT IS NULL
				   AND DTSERVPREST = C_SERVPRST.DTSERVPREST
				   AND CDTIPOSERV = C_SERVPRST.CDTIPOSERV 
				   AND NRSERVCONT = C_SERVPRST.NRSERVCONT
				   AND NRSERVPREST = C_SERVPRST.NRSERVPREST
				   AND CDEMPRESA = C_SERVPRST.CDEMPRESA
				   AND CDFUNC = C_SERVPRST.CDFUNC;	

		END LOOP;
	  END IF;
   END IF;
END;