/* Sistemas Integrados TECNISA

Nome: 00NG_CDPTRGS_DTULTATU_CALEPRODUCAO.SQL

Descrio:

Atualiza a data de ultima atualizao da tabela CALEPRODUCAO

Criao:
07/05/2007 Ronald Reis
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CALEPRODUCAO' and
            type = 'TR'                      and
            u.uid = o.uid                    and
            u.name = USER)
  DROP TRIGGER DTULTATU_CALEPRODUCAO
  GO

CREATE TRIGGER DTULTATU_CALEPRODUCAO
ON CALEPRODUCAO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CALEPRODUCAO', CDFILIAL, 'CDFILIAL=' + CDFILIAL+
                               '; CDPERIPRODU=' + CDPERIPRODU +
                               '; DTPRODUCAO=' + CONVERT(VARCHAR, DTPRODUCAO, 103)+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CALEPRODUCAO
      SET DTULTATUCALP = GETDATE()
      FROM INSERTED
      WHERE ISNULL(CALEPRODUCAO.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0) AND
            ISNULL(CALEPRODUCAO.CDPERIPRODU,0) = ISNULL(INSERTED.CDPERIPRODU,0) AND
            ISNULL(CALEPRODUCAO.DTPRODUCAO,0) = ISNULL(INSERTED.DTPRODUCAO,0)
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_CALEPRODUCAO','4.11.134';
GO
